<template>
  <div class="profile">
    <div class="flex items-center justify-center">
      <div class="flex gap-2 mr-2">
        <img
          class="max-w-[35px]"
          :src="
            getAssetImage(
              'assets/theme/light_flexible_1/desktop/images/menu/userlogo.png'
            )
          "
          loading="lazy"
        />
        <span class="self-center">{{ username }}</span>
      </div>
      <div
        class="flex text-[16px] items-center justify-center account-block-resize pl-2 seperator relative"
      >
        <div class="flex items-center gap-1 whitespace-nowrap">
          <span>
            {{ currency }}
          </span>
          <span class="text-lg">{{ mainBalanceForDisplay }}</span>
          <font-awesome-icon
            :class="[isLoading ? 'inline-block fa-spin' : 'hidden']"
            icon="spinner"
          ></font-awesome-icon>
          <font-awesome-icon
            icon="arrows-rotate"
            :class="[isLoading ? 'hidden' : 'inline-block']"
            class="cursor-pointer"
            @click="getMultiWallets()"
          />
          <span
            v-if="isSuspended"
            :title="$t('account_is_suspended')"
            class="flex items-center gap-1 suspended-icon"
          >
            <font-awesome-icon
              icon="exclamation-circle"
              class="cursor-pointer text-lg ml-[3px]"
            >
            </font-awesome-icon>
          </span>
          <div class="ml-1">
            <img
              class="icon-drop-down"
              :src="
                getAssetImage(
                  'assets/theme/light_flexible_1/desktop/images/menu/dropDown.png'
                )
              "
              loading="lazy"
            />
          </div>
        </div>
      </div>
    </div>
    <div class="relative bottom-0">
      <div class="user-profile-menu">
        <nuxt-link :to="ROUTES.ACCOUNT.INFO">
          <div class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/profile.png'
                  )
                "
                alt="profile"
              />
            </div>
            <span>{{ $t("profile") }}</span>
          </div>
        </nuxt-link>
        <nuxt-link to="/referral">
          <div v-if="isReferralEnabled && !isV2ReferralEnabled" class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/referral.png'
                  )
                "
                alt="referral"
              />
            </div>
            <span>{{ $t("referral") }}</span>
          </div>
        </nuxt-link>
        <nuxt-link to="/referral-v2/information">
          <div v-if="isV2ReferralEnabled" class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/referral.png'
                  )
                "
                alt="referral"
              />
            </div>
            <span>{{ $t("referral") }}</span>
          </div>
        </nuxt-link>
        <nuxt-link to="/my-promotion">
          <div v-if="isPromotionTabEnabled" class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/promotion.png'
                  )
                "
                alt="promotion"
              />
            </div>
            <span>{{ $t("promotion") }}</span>
          </div>
        </nuxt-link>
        <nuxt-link :to="BET_HISTORY_ROUTES.INDEX">
          <div class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/mybet.png'
                  )
                "
                alt="mybet"
              />
            </div>
            <span>{{ $t("my_bets") }}</span>
          </div>
        </nuxt-link>
        <nuxt-link to="/transaction-history/winlose">
          <div class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/statement.png'
                  )
                "
                alt="statement"
              />
            </div>
            <span>{{ $t("statement") }}</span>
          </div>
        </nuxt-link>
        <nuxt-link to="/wallet">
          <div class="user-profile-menu-item">
            <div class="dropdown-icon">
              <img
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/menu/balance.png'
                  )
                "
                alt="balance"
              />
            </div>
            <span>{{ $t("balance") }}</span>
          </div>
        </nuxt-link>
        <div class="user-profile-menu-item sign-out" @click="logout">
          <span>{{ $t("logout") }}</span>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import useBalanceInfo from "@/composables/useBalanceInfo";
import { store } from '~~/store';
import { appStore } from '~~/store/app';

export default defineComponent({
  props: {
    username: {
      type: String,
      default: "",
    },
    isReferralEnabled: {
      type: Boolean,
      default: false,
    },
    isPromotionTabEnabled: {
      type: Boolean,
      default: false,
    },
    isSuspended: {
      type: Boolean,
      default: false,
    },
  },
  setup() {
    const { balanceUser, getBalance, currency, isLoading, mainBalanceForDisplay, getMultiWallets, } = useBalanceInfo();
    const logout = async () => {
      await apis.getLogout();
    };
    const { getAssetImage } = commonHelper;
    const profileMenuIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/menu/profile_menu_icon.png"
    )})`;
    const isV2ReferralEnabled = computed(() => store.state.isCashPlayer && appStore.state.IsReferralV2Enabled && store.state.IsShowReferralPage);
    return {
      balanceUser,
      getBalance,
      currency,
      logout,
      isLoading,
      getAssetImage,
      profileMenuIcon,
      isV2ReferralEnabled,
      mainBalanceForDisplay,
      getMultiWallets,
    };
  },
});
</script>

<style lang="postcss" scoped>
.profile {
  @apply cursor-pointer flex items-center relative;
}

.profile:hover .icon-drop-down {
  transform: rotate(0);
}

.profile:hover .user-profile-menu .sign-out {
  border: 1px solid #e2e7ef;
}

.profile:hover .user-profile-menu {
  width: 200px;
  height: fit-content;
  padding: 10px 0;
  transition: 0.3s ease-in-out;
}

.profile:hover .user-profile-menu-item {
  height: 49px;
  width: 172px;
}

.profile:hover .user-profile-menu::before {
  display: block;
}

.profile:hover .user-profile-menu .user-profile-menu-item {
  width: 172px;
}

.icon-drop-down {
  @apply max-w-[15px] rotate-180 transition-transform duration-300 ease-in-out;
}

.user-profile-menu {
  @apply absolute w-0 right-0 top-[26px] p-0 rounded-[5px] bg-white overflow-hidden transition-all duration-500 ease-in-out;
  height: fit-content;
  z-index: 5;
}

.user-profile-menu::before {
  @apply bg-white absolute hidden;
  content: "";
  width: 10px;
  height: 10px;
  top: -5px;
  right: 15px;
  rotate: 45deg;
  transition-delay: 100ms ease-in-out;
}

.user-profile-menu .sign-out {
  height: 46px;
  border: none;
  border-radius: 4px;
  font-size: 14px;
  justify-content: center;
}

.user-profile-menu .sign-out:hover {
  border: 1px solid #4885fb !important;
}

.user-profile-menu .sign-out span {
  color: #e2e7ef;
  transition: 0.3 ease-in-out;
}

.user-profile-menu .sign-out:hover {
  border-color: #4885fb;
}

.user-profile-menu-item {
  @apply w-[190px] h-[49px] flex items-center mx-auto relative right-0 overflow-hidden;
  transition: all 300ms ease-in-out 100ms;
}

.user-profile-menu-item span {
  font-size: 16px;
  margin: auto 25px;
}

.user-profile-menu-item .notification {
  background-image: linear-gradient(90deg, #62b3ff, var(--selected));
  width: 16px;
  height: 16px;
  font-size: 12px;
  display: flex;
  color: white;
  align-items: center;
  justify-content: center;
  border-radius: 50%;
}

.user-profile-menu-item:hover span {
  color: var(--selected);
}

.seperator::before {
  content: "";
  position: absolute;
  left: 0;
  width: 1px;
  height: 16px;
  background: var(--text);
  top: 50%;
  transform: translate(-50%, -50%);
}
.dropdown-icon {
  flex-shrink: 0;
  width: 19px;
  height: 19px;
  background-size: cover;
  /*background-image: v-bind('profileMenuIcon');*/
}
</style>
